// this program demonstrates that erl_compare_ext is broken wrt tuples.

// to compile:
// gcc  -I/usr/lib/erlang/lib/erl_interface-3.5.5.3/include flass.c -o flass -L/usr/lib/erlang/lib/erl_interface-3.5.5.3/lib -lerl_interface -lei -lpthread

#include <assert.h>
#include <erl_interface.h>
#include <stdio.h>

int main (void)
{
  erl_init (NULL, 0);
  my_erl_init_marshal ();

  // erlang:term_to_binary ({'b'}).
  unsigned char term1[] = { 131, 104, 1, 100, 0, 1, 98 };
  // erlang:term_to_binary ({'a', 'a'})
  unsigned char term2[] = { 131, 104, 2, 100, 0, 1, 97, 100, 0, 1, 97 };

  fprintf (stderr, "my_erl_compare_ext (term1, term2) = %d\n", my_erl_compare_ext (term1, term2));
  fprintf (stderr, "my_erl_compare_ext (term2, term1) = %d\n", my_erl_compare_ext (term2, term1));
  assert (my_erl_compare_ext (term1, term2) == -my_erl_compare_ext (term2, term1));

  fprintf (stderr, "erl_compare_ext (term1, term2) = %d\n", erl_compare_ext (term1, term2));
  fprintf (stderr, "erl_compare_ext (term2, term1) = %d\n", erl_compare_ext (term2, term1));
  assert (erl_compare_ext (term1, term2) == -erl_compare_ext (term2, term1));

  return 0;
}
